/* gpaste-settings.c generated by valac 0.13.3, the Vala compiler
 * generated from gpaste-settings.vala, do not modify */

/*
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *      Copyright 2011 Marc-Antoine Perennou <Marc-Antoine@Perennou.com>
 *
 *      This file is part of GPaste.
 *
 *      GPaste is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      GPaste is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with GPaste.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <stdio.h>


#define GPASTE_SETTINGS_TYPE_WINDOW (gpaste_settings_window_get_type ())
#define GPASTE_SETTINGS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindow))
#define GPASTE_SETTINGS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowClass))
#define GPASTE_SETTINGS_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_SETTINGS_TYPE_WINDOW))
#define GPASTE_SETTINGS_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_SETTINGS_TYPE_WINDOW))
#define GPASTE_SETTINGS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowClass))

typedef struct _GPasteSettingsWindow GPasteSettingsWindow;
typedef struct _GPasteSettingsWindowClass GPasteSettingsWindowClass;
typedef struct _GPasteSettingsWindowPrivate GPasteSettingsWindowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GPASTE_SETTINGS_TYPE_MAIN (gpaste_settings_main_get_type ())
#define GPASTE_SETTINGS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMain))
#define GPASTE_SETTINGS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainClass))
#define GPASTE_SETTINGS_IS_MAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPASTE_SETTINGS_TYPE_MAIN))
#define GPASTE_SETTINGS_IS_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPASTE_SETTINGS_TYPE_MAIN))
#define GPASTE_SETTINGS_MAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainClass))

typedef struct _GPasteSettingsMain GPasteSettingsMain;
typedef struct _GPasteSettingsMainClass GPasteSettingsMainClass;
typedef struct _Block1Data Block1Data;
typedef struct _GPasteSettingsMainPrivate GPasteSettingsMainPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GPasteSettingsWindow {
	GtkWindow parent_instance;
	GPasteSettingsWindowPrivate * priv;
};

struct _GPasteSettingsWindowClass {
	GtkWindowClass parent_class;
};

struct _GPasteSettingsWindowPrivate {
	GtkCheckButton* primary_to_history_button;
	GtkCheckButton* synchronize_clipboards_button;
	GtkCheckButton* track_changes_button;
	GtkCheckButton* save_history_button;
	GtkCheckButton* shutdown_on_exit_button;
	GtkSpinButton* max_history_size_button;
	GtkSpinButton* element_size_button;
};

struct _Block1Data {
	int _ref_count_;
	GPasteSettingsWindow * self;
	GPasteSettingsMain* app;
};

struct _GPasteSettingsMain {
	GtkApplication parent_instance;
	GPasteSettingsMainPrivate * priv;
};

struct _GPasteSettingsMainClass {
	GtkApplicationClass parent_class;
};

struct _GPasteSettingsMainPrivate {
	GSettings* settings;
	GPasteSettingsWindow* window;
};


static gpointer gpaste_settings_window_parent_class = NULL;
static gpointer gpaste_settings_main_parent_class = NULL;

GType gpaste_settings_window_get_type (void) G_GNUC_CONST;
#define GPASTE_SETTINGS_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_SETTINGS_TYPE_WINDOW, GPasteSettingsWindowPrivate))
enum  {
	GPASTE_SETTINGS_WINDOW_DUMMY_PROPERTY,
	GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY,
	GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_SETTINGS_WINDOW_TRACK_CHANGES,
	GPASTE_SETTINGS_WINDOW_SAVE_HISTORY,
	GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT,
	GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE,
	GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE
};
GPasteSettingsWindow* gpaste_settings_window_new (GtkApplication* app);
GPasteSettingsWindow* gpaste_settings_window_construct (GType object_type, GtkApplication* app);
static void gpaste_settings_window_fill (GPasteSettingsWindow* self);
GType gpaste_settings_main_get_type (void) G_GNUC_CONST;
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
gboolean gpaste_settings_main_get_primary_to_history (GPasteSettingsMain* self);
void gpaste_settings_window_set_primary_to_history (GPasteSettingsWindow* self, gboolean value);
static void __lambda1_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_primary_to_history (GPasteSettingsWindow* self);
void gpaste_settings_main_set_primary_to_history (GPasteSettingsMain* self, gboolean value);
static void ___lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_synchronize_clipboards (GPasteSettingsMain* self);
void gpaste_settings_window_set_synchronize_clipboards (GPasteSettingsWindow* self, gboolean value);
static void __lambda2_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_synchronize_clipboards (GPasteSettingsWindow* self);
void gpaste_settings_main_set_synchronize_clipboards (GPasteSettingsMain* self, gboolean value);
static void ___lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_track_changes (GPasteSettingsMain* self);
void gpaste_settings_window_set_track_changes (GPasteSettingsWindow* self, gboolean value);
static void __lambda3_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_track_changes (GPasteSettingsWindow* self);
void gpaste_settings_main_set_track_changes (GPasteSettingsMain* self, gboolean value);
static void ___lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_save_history (GPasteSettingsMain* self);
void gpaste_settings_window_set_save_history (GPasteSettingsWindow* self, gboolean value);
static void __lambda4_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_save_history (GPasteSettingsWindow* self);
void gpaste_settings_main_set_save_history (GPasteSettingsMain* self, gboolean value);
static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean gpaste_settings_main_get_shutdown_on_exit (GPasteSettingsMain* self);
void gpaste_settings_window_set_shutdown_on_exit (GPasteSettingsWindow* self, gboolean value);
static void __lambda5_ (Block1Data* _data1_);
gboolean gpaste_settings_window_get_shutdown_on_exit (GPasteSettingsWindow* self);
void gpaste_settings_main_set_shutdown_on_exit (GPasteSettingsMain* self, gboolean value);
static void ___lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
guint32 gpaste_settings_main_get_max_history_size (GPasteSettingsMain* self);
void gpaste_settings_window_set_max_history_size (GPasteSettingsWindow* self, guint32 value);
static void __lambda6_ (Block1Data* _data1_);
guint32 gpaste_settings_window_get_max_history_size (GPasteSettingsWindow* self);
void gpaste_settings_main_set_max_history_size (GPasteSettingsMain* self, guint32 value);
static void ___lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
guint32 gpaste_settings_main_get_element_size (GPasteSettingsMain* self);
void gpaste_settings_window_set_element_size (GPasteSettingsWindow* self, guint32 value);
static void __lambda7_ (Block1Data* _data1_);
guint32 gpaste_settings_window_get_element_size (GPasteSettingsWindow* self);
void gpaste_settings_main_set_element_size (GPasteSettingsMain* self, guint32 value);
static void ___lambda7__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self);
static void gpaste_settings_window_finalize (GObject* obj);
static void _vala_gpaste_settings_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_settings_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define GPASTE_SETTINGS_MAIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPASTE_SETTINGS_TYPE_MAIN, GPasteSettingsMainPrivate))
enum  {
	GPASTE_SETTINGS_MAIN_DUMMY_PROPERTY,
	GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE,
	GPASTE_SETTINGS_MAIN_ELEMENT_SIZE,
	GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY,
	GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS,
	GPASTE_SETTINGS_MAIN_TRACK_CHANGES,
	GPASTE_SETTINGS_MAIN_SAVE_HISTORY,
	GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT
};
GPasteSettingsMain* gpaste_settings_main_new (void);
GPasteSettingsMain* gpaste_settings_main_construct (GType object_type);
static void gpaste_settings_main_init (GPasteSettingsMain* self);
static void _gpaste_settings_main_init_g_application_activate (GApplication* _sender, gpointer self);
static void __lambda0_ (GPasteSettingsMain* self, const gchar* key);
static void ___lambda0__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
gint gpaste_settings_main_main (gchar** args, int args_length1);
static GVariant* _variant_new1 (guint32 value);
static GVariant* _variant_new2 (guint32 value);
static void gpaste_settings_main_finalize (GObject* obj);
static void _vala_gpaste_settings_main_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpaste_settings_main_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GPasteSettingsWindow* gpaste_settings_window_construct (GType object_type, GtkApplication* app) {
	GPasteSettingsWindow * self = NULL;
	const gchar* _tmp0_ = NULL;
	GtkApplication* _tmp1_;
	g_return_val_if_fail (app != NULL, NULL);
	self = (GPasteSettingsWindow*) g_object_new (object_type, "type", GTK_WINDOW_TOPLEVEL, NULL);
	_tmp0_ = _ ("GPaste Settings");
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
	_tmp1_ = app;
	gtk_window_set_application ((GtkWindow*) self, _tmp1_);
	gtk_window_set_position ((GtkWindow*) self, GTK_WIN_POS_CENTER);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	gpaste_settings_window_fill (self);
	return self;
}


GPasteSettingsWindow* gpaste_settings_window_new (GtkApplication* app) {
	return gpaste_settings_window_construct (GPASTE_SETTINGS_TYPE_WINDOW, app);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		_g_object_unref0 (_data1_->self);
		_g_object_unref0 (_data1_->app);
		g_slice_free (Block1Data, _data1_);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void __lambda1_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_primary_to_history (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_primary_to_history (_data1_->app, _tmp1_);
}


static void ___lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda1_ (self);
}


static void __lambda2_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_synchronize_clipboards (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_synchronize_clipboards (_data1_->app, _tmp1_);
}


static void ___lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda2_ (self);
}


static void __lambda3_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_track_changes (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_track_changes (_data1_->app, _tmp1_);
}


static void ___lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda3_ (self);
}


static void __lambda4_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_save_history (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_save_history (_data1_->app, _tmp1_);
}


static void ___lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda4_ (self);
}


static void __lambda5_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_shutdown_on_exit (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_shutdown_on_exit (_data1_->app, _tmp1_);
}


static void ___lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	__lambda5_ (self);
}


static void __lambda6_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	guint32 _tmp0_;
	guint32 _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_max_history_size (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_max_history_size (_data1_->app, _tmp1_);
}


static void ___lambda6__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	__lambda6_ (self);
}


static void __lambda7_ (Block1Data* _data1_) {
	GPasteSettingsWindow * self;
	guint32 _tmp0_;
	guint32 _tmp1_;
	self = _data1_->self;
	_tmp0_ = gpaste_settings_window_get_element_size (self);
	_tmp1_ = _tmp0_;
	gpaste_settings_main_set_element_size (_data1_->app, _tmp1_);
}


static void ___lambda7__gtk_adjustment_value_changed (GtkAdjustment* _sender, gpointer self) {
	__lambda7_ (self);
}


static void gpaste_settings_window_fill (GPasteSettingsWindow* self) {
	Block1Data* _data1_;
	GtkVBox* _tmp0_;
	GtkVBox* _tmp1_;
	GtkVBox* labels_vbox;
	const gchar* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* history_size_label;
	const gchar* _tmp5_ = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* element_size_label;
	GtkApplication* _tmp8_;
	GtkApplication* _tmp9_;
	GPasteSettingsMain* _tmp10_;
	const gchar* _tmp11_ = NULL;
	GtkCheckButton* _tmp12_;
	GtkCheckButton* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GtkCheckButton* _tmp16_;
	const gchar* _tmp17_ = NULL;
	GtkCheckButton* _tmp18_;
	GtkCheckButton* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	GtkCheckButton* _tmp22_;
	const gchar* _tmp23_ = NULL;
	GtkCheckButton* _tmp24_;
	GtkCheckButton* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	GtkCheckButton* _tmp28_;
	const gchar* _tmp29_ = NULL;
	GtkCheckButton* _tmp30_;
	GtkCheckButton* _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	GtkCheckButton* _tmp34_;
	const gchar* _tmp35_ = NULL;
	GtkCheckButton* _tmp36_;
	GtkCheckButton* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GtkCheckButton* _tmp40_;
	GtkSpinButton* _tmp41_;
	GtkSpinButton* _tmp42_;
	guint32 _tmp43_;
	guint32 _tmp44_;
	GtkSpinButton* _tmp45_;
	GtkAdjustment* _tmp46_ = NULL;
	GtkSpinButton* _tmp47_;
	GtkSpinButton* _tmp48_;
	guint32 _tmp49_;
	guint32 _tmp50_;
	GtkSpinButton* _tmp51_;
	GtkAdjustment* _tmp52_ = NULL;
	GtkVBox* _tmp53_;
	GtkVBox* _tmp54_;
	GtkVBox* values_vbox;
	GtkSpinButton* _tmp55_;
	GtkSpinButton* _tmp56_;
	GtkHBox* _tmp57_;
	GtkHBox* _tmp58_;
	GtkHBox* values_hbox;
	GtkVBox* _tmp59_;
	GtkVBox* _tmp60_;
	GtkVBox* vbox;
	GtkCheckButton* _tmp61_;
	GtkCheckButton* _tmp62_;
	GtkCheckButton* _tmp63_;
	GtkCheckButton* _tmp64_;
	GtkCheckButton* _tmp65_;
	g_return_if_fail (self != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = (GtkVBox*) gtk_vbox_new (FALSE, 10);
	_tmp1_ = g_object_ref_sink (_tmp0_);
	labels_vbox = _tmp1_;
	_tmp2_ = _ ("Max history size: ");
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	_tmp4_ = g_object_ref_sink (_tmp3_);
	history_size_label = _tmp4_;
	_tmp5_ = _ ("Max element size when displaying: ");
	_tmp6_ = (GtkLabel*) gtk_label_new (_tmp5_);
	_tmp7_ = g_object_ref_sink (_tmp6_);
	element_size_label = _tmp7_;
	gtk_container_add ((GtkContainer*) labels_vbox, (GtkWidget*) history_size_label);
	gtk_container_add ((GtkContainer*) labels_vbox, (GtkWidget*) element_size_label);
	_tmp8_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp9_ = _tmp8_;
	_tmp10_ = _g_object_ref0 (GPASTE_SETTINGS_IS_MAIN (_tmp9_) ? ((GPasteSettingsMain*) _tmp9_) : NULL);
	_data1_->app = _tmp10_;
	_tmp11_ = _ ("_Primary selection affects history");
	_tmp12_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp11_);
	_tmp13_ = g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->priv->primary_to_history_button);
	self->priv->primary_to_history_button = _tmp13_;
	_tmp14_ = gpaste_settings_main_get_primary_to_history (_data1_->app);
	_tmp15_ = _tmp14_;
	gpaste_settings_window_set_primary_to_history (self, _tmp15_);
	_tmp16_ = self->priv->primary_to_history_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp16_, "toggled", (GCallback) ___lambda1__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp17_ = _ ("_Synchronize clipboard with primary selection");
	_tmp18_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp17_);
	_tmp19_ = g_object_ref_sink (_tmp18_);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	self->priv->synchronize_clipboards_button = _tmp19_;
	_tmp20_ = gpaste_settings_main_get_synchronize_clipboards (_data1_->app);
	_tmp21_ = _tmp20_;
	gpaste_settings_window_set_synchronize_clipboards (self, _tmp21_);
	_tmp22_ = self->priv->synchronize_clipboards_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp22_, "toggled", (GCallback) ___lambda2__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp23_ = _ ("_Track clipboard changes");
	_tmp24_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp23_);
	_tmp25_ = g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->track_changes_button);
	self->priv->track_changes_button = _tmp25_;
	_tmp26_ = gpaste_settings_main_get_track_changes (_data1_->app);
	_tmp27_ = _tmp26_;
	gpaste_settings_window_set_track_changes (self, _tmp27_);
	_tmp28_ = self->priv->track_changes_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp28_, "toggled", (GCallback) ___lambda3__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp29_ = _ ("_Save history");
	_tmp30_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp29_);
	_tmp31_ = g_object_ref_sink (_tmp30_);
	_g_object_unref0 (self->priv->save_history_button);
	self->priv->save_history_button = _tmp31_;
	_tmp32_ = gpaste_settings_main_get_save_history (_data1_->app);
	_tmp33_ = _tmp32_;
	gpaste_settings_window_set_save_history (self, _tmp33_);
	_tmp34_ = self->priv->save_history_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp34_, "toggled", (GCallback) ___lambda4__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp35_ = _ ("Stop tracking clipboard changes when _quitting the applet");
	_tmp36_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_tmp35_);
	_tmp37_ = g_object_ref_sink (_tmp36_);
	_g_object_unref0 (self->priv->shutdown_on_exit_button);
	self->priv->shutdown_on_exit_button = _tmp37_;
	_tmp38_ = gpaste_settings_main_get_shutdown_on_exit (_data1_->app);
	_tmp39_ = _tmp38_;
	gpaste_settings_window_set_shutdown_on_exit (self, _tmp39_);
	_tmp40_ = self->priv->shutdown_on_exit_button;
	g_signal_connect_data ((GtkToggleButton*) _tmp40_, "toggled", (GCallback) ___lambda5__gtk_toggle_button_toggled, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp41_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 5, (gdouble) 255, (gdouble) 5);
	_tmp42_ = g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->max_history_size_button);
	self->priv->max_history_size_button = _tmp42_;
	_tmp43_ = gpaste_settings_main_get_max_history_size (_data1_->app);
	_tmp44_ = _tmp43_;
	gpaste_settings_window_set_max_history_size (self, _tmp44_);
	_tmp45_ = self->priv->max_history_size_button;
	_tmp46_ = gtk_spin_button_get_adjustment (_tmp45_);
	g_signal_connect_data (_tmp46_, "value-changed", (GCallback) ___lambda6__gtk_adjustment_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp47_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 255, (gdouble) 5);
	_tmp48_ = g_object_ref_sink (_tmp47_);
	_g_object_unref0 (self->priv->element_size_button);
	self->priv->element_size_button = _tmp48_;
	_tmp49_ = gpaste_settings_main_get_element_size (_data1_->app);
	_tmp50_ = _tmp49_;
	gpaste_settings_window_set_element_size (self, _tmp50_);
	_tmp51_ = self->priv->element_size_button;
	_tmp52_ = gtk_spin_button_get_adjustment (_tmp51_);
	g_signal_connect_data (_tmp52_, "value-changed", (GCallback) ___lambda7__gtk_adjustment_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp53_ = (GtkVBox*) gtk_vbox_new (TRUE, 10);
	_tmp54_ = g_object_ref_sink (_tmp53_);
	values_vbox = _tmp54_;
	_tmp55_ = self->priv->max_history_size_button;
	gtk_container_add ((GtkContainer*) values_vbox, (GtkWidget*) _tmp55_);
	_tmp56_ = self->priv->element_size_button;
	gtk_container_add ((GtkContainer*) values_vbox, (GtkWidget*) _tmp56_);
	_tmp57_ = (GtkHBox*) gtk_hbox_new (FALSE, 10);
	_tmp58_ = g_object_ref_sink (_tmp57_);
	values_hbox = _tmp58_;
	gtk_container_add ((GtkContainer*) values_hbox, (GtkWidget*) labels_vbox);
	gtk_container_add ((GtkContainer*) values_hbox, (GtkWidget*) values_vbox);
	_tmp59_ = (GtkVBox*) gtk_vbox_new (FALSE, 10);
	_tmp60_ = g_object_ref_sink (_tmp59_);
	vbox = _tmp60_;
	_tmp61_ = self->priv->primary_to_history_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp61_);
	_tmp62_ = self->priv->synchronize_clipboards_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp62_);
	_tmp63_ = self->priv->track_changes_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp63_);
	_tmp64_ = self->priv->save_history_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp64_);
	_tmp65_ = self->priv->shutdown_on_exit_button;
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) _tmp65_);
	gtk_container_add ((GtkContainer*) vbox, (GtkWidget*) values_hbox);
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) vbox);
	_g_object_unref0 (vbox);
	_g_object_unref0 (values_hbox);
	_g_object_unref0 (values_vbox);
	_g_object_unref0 (element_size_label);
	_g_object_unref0 (history_size_label);
	_g_object_unref0 (labels_vbox);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


gboolean gpaste_settings_window_get_primary_to_history (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->primary_to_history_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_primary_to_history (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->primary_to_history_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "primary-to-history");
}


gboolean gpaste_settings_window_get_synchronize_clipboards (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->synchronize_clipboards_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_synchronize_clipboards (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->synchronize_clipboards_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_settings_window_get_track_changes (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->track_changes_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_track_changes (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->track_changes_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "track-changes");
}


gboolean gpaste_settings_window_get_save_history (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->save_history_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_save_history (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->save_history_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "save-history");
}


gboolean gpaste_settings_window_get_shutdown_on_exit (GPasteSettingsWindow* self) {
	gboolean result;
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->shutdown_on_exit_button;
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	result = _tmp1_;
	return result;
}


void gpaste_settings_window_set_shutdown_on_exit (GPasteSettingsWindow* self, gboolean value) {
	GtkCheckButton* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->shutdown_on_exit_button;
	_tmp1_ = value;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp1_);
	g_object_notify ((GObject *) self, "shutdown-on-exit");
}


guint32 gpaste_settings_window_get_max_history_size (GPasteSettingsWindow* self) {
	guint32 result;
	GtkSpinButton* _tmp0_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->max_history_size_button;
	_tmp1_ = gtk_spin_button_get_value_as_int (_tmp0_);
	result = (guint32) _tmp1_;
	return result;
}


void gpaste_settings_window_set_max_history_size (GPasteSettingsWindow* self, guint32 value) {
	GtkSpinButton* _tmp0_;
	GtkAdjustment* _tmp1_ = NULL;
	guint32 _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->max_history_size_button;
	_tmp1_ = gtk_spin_button_get_adjustment (_tmp0_);
	_tmp2_ = value;
	gtk_adjustment_set_value (_tmp1_, (gdouble) _tmp2_);
	g_object_notify ((GObject *) self, "max-history-size");
}


guint32 gpaste_settings_window_get_element_size (GPasteSettingsWindow* self) {
	guint32 result;
	GtkSpinButton* _tmp0_;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->element_size_button;
	_tmp1_ = gtk_spin_button_get_value_as_int (_tmp0_);
	result = (guint32) _tmp1_;
	return result;
}


void gpaste_settings_window_set_element_size (GPasteSettingsWindow* self, guint32 value) {
	GtkSpinButton* _tmp0_;
	GtkAdjustment* _tmp1_ = NULL;
	guint32 _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->element_size_button;
	_tmp1_ = gtk_spin_button_get_adjustment (_tmp0_);
	_tmp2_ = value;
	gtk_adjustment_set_value (_tmp1_, (gdouble) _tmp2_);
	g_object_notify ((GObject *) self, "element-size");
}


static void gpaste_settings_window_class_init (GPasteSettingsWindowClass * klass) {
	gpaste_settings_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteSettingsWindowPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_settings_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_settings_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_settings_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_SAVE_HISTORY, g_param_spec_boolean ("save-history", "save-history", "save-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT, g_param_spec_boolean ("shutdown-on-exit", "shutdown-on-exit", "shutdown-on-exit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE, g_param_spec_uint ("element-size", "element-size", "element-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpaste_settings_window_instance_init (GPasteSettingsWindow * self) {
	self->priv = GPASTE_SETTINGS_WINDOW_GET_PRIVATE (self);
}


static void gpaste_settings_window_finalize (GObject* obj) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (obj);
	_g_object_unref0 (self->priv->primary_to_history_button);
	_g_object_unref0 (self->priv->synchronize_clipboards_button);
	_g_object_unref0 (self->priv->track_changes_button);
	_g_object_unref0 (self->priv->save_history_button);
	_g_object_unref0 (self->priv->shutdown_on_exit_button);
	_g_object_unref0 (self->priv->max_history_size_button);
	_g_object_unref0 (self->priv->element_size_button);
	G_OBJECT_CLASS (gpaste_settings_window_parent_class)->finalize (obj);
}


GType gpaste_settings_window_get_type (void) {
	static volatile gsize gpaste_settings_window_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_settings_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteSettingsWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_settings_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteSettingsWindow), 0, (GInstanceInitFunc) gpaste_settings_window_instance_init, NULL };
		GType gpaste_settings_window_type_id;
		gpaste_settings_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "GPasteSettingsWindow", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_settings_window_type_id__volatile, gpaste_settings_window_type_id);
	}
	return gpaste_settings_window_type_id__volatile;
}


static void _vala_gpaste_settings_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (object);
	switch (property_id) {
		case GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_settings_window_get_primary_to_history (self));
		break;
		case GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_settings_window_get_synchronize_clipboards (self));
		break;
		case GPASTE_SETTINGS_WINDOW_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_settings_window_get_track_changes (self));
		break;
		case GPASTE_SETTINGS_WINDOW_SAVE_HISTORY:
		g_value_set_boolean (value, gpaste_settings_window_get_save_history (self));
		break;
		case GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT:
		g_value_set_boolean (value, gpaste_settings_window_get_shutdown_on_exit (self));
		break;
		case GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_settings_window_get_max_history_size (self));
		break;
		case GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE:
		g_value_set_uint (value, gpaste_settings_window_get_element_size (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_settings_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteSettingsWindow * self;
	self = GPASTE_SETTINGS_WINDOW (object);
	switch (property_id) {
		case GPASTE_SETTINGS_WINDOW_PRIMARY_TO_HISTORY:
		gpaste_settings_window_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_SYNCHRONIZE_CLIPBOARDS:
		gpaste_settings_window_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_TRACK_CHANGES:
		gpaste_settings_window_set_track_changes (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_SAVE_HISTORY:
		gpaste_settings_window_set_save_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_SHUTDOWN_ON_EXIT:
		gpaste_settings_window_set_shutdown_on_exit (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_WINDOW_MAX_HISTORY_SIZE:
		gpaste_settings_window_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_WINDOW_ELEMENT_SIZE:
		gpaste_settings_window_set_element_size (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _gpaste_settings_main_init_g_application_activate (GApplication* _sender, gpointer self) {
	gpaste_settings_main_init (self);
}


static void __lambda0_ (GPasteSettingsMain* self, const gchar* key) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	static GQuark _tmp2_label6 = 0;
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("max-history-size")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp4_;
				guint32 _tmp5_;
				guint32 _tmp6_;
				_tmp4_ = self->priv->window;
				_tmp5_ = gpaste_settings_main_get_max_history_size (self);
				_tmp6_ = _tmp5_;
				gpaste_settings_window_set_max_history_size (_tmp4_, _tmp6_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("element-size")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp7_;
				guint32 _tmp8_;
				guint32 _tmp9_;
				_tmp7_ = self->priv->window;
				_tmp8_ = gpaste_settings_main_get_element_size (self);
				_tmp9_ = _tmp8_;
				gpaste_settings_window_set_element_size (_tmp7_, _tmp9_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("primary-to-history")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
				_tmp10_ = self->priv->window;
				_tmp11_ = gpaste_settings_main_get_primary_to_history (self);
				_tmp12_ = _tmp11_;
				gpaste_settings_window_set_primary_to_history (_tmp10_, _tmp12_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("synchronize_clipboards")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp13_;
				gboolean _tmp14_;
				gboolean _tmp15_;
				_tmp13_ = self->priv->window;
				_tmp14_ = gpaste_settings_main_get_synchronize_clipboards (self);
				_tmp15_ = _tmp14_;
				gpaste_settings_window_set_synchronize_clipboards (_tmp13_, _tmp15_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("track-changes")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp16_;
				gboolean _tmp17_;
				gboolean _tmp18_;
				_tmp16_ = self->priv->window;
				_tmp17_ = gpaste_settings_main_get_track_changes (self);
				_tmp18_ = _tmp17_;
				gpaste_settings_window_set_track_changes (_tmp16_, _tmp18_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("save-history")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp19_;
				gboolean _tmp20_;
				gboolean _tmp21_;
				_tmp19_ = self->priv->window;
				_tmp20_ = gpaste_settings_main_get_save_history (self);
				_tmp21_ = _tmp20_;
				gpaste_settings_window_set_save_history (_tmp19_, _tmp21_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("shutdown-on-exit")))) {
		switch (0) {
			default:
			{
				GPasteSettingsWindow* _tmp22_;
				gboolean _tmp23_;
				gboolean _tmp24_;
				_tmp22_ = self->priv->window;
				_tmp23_ = gpaste_settings_main_get_shutdown_on_exit (self);
				_tmp24_ = _tmp23_;
				gpaste_settings_window_set_shutdown_on_exit (_tmp22_, _tmp24_);
				break;
			}
		}
	}
}


static void ___lambda0__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
	__lambda0_ (self, key);
}


GPasteSettingsMain* gpaste_settings_main_construct (GType object_type) {
	GPasteSettingsMain * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	self = (GPasteSettingsMain*) g_object_new (object_type, "application-id", "org.gnome.GPaste.Settings", NULL);
	g_signal_connect_object ((GApplication*) self, "activate", (GCallback) _gpaste_settings_main_init_g_application_activate, self, 0);
	_tmp0_ = g_settings_new ("org.gnome.GPaste");
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = self->priv->settings;
	g_signal_connect_object (_tmp1_, "changed", (GCallback) ___lambda0__g_settings_changed, self, 0);
	return self;
}


GPasteSettingsMain* gpaste_settings_main_new (void) {
	return gpaste_settings_main_construct (GPASTE_SETTINGS_TYPE_MAIN);
}


static void gpaste_settings_main_init (GPasteSettingsMain* self) {
	GPasteSettingsWindow* _tmp0_;
	GPasteSettingsWindow* _tmp1_;
	GPasteSettingsWindow* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gpaste_settings_window_new ((GtkApplication*) self);
	_tmp1_ = g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp1_;
	_tmp2_ = self->priv->window;
	gtk_widget_show_all ((GtkWidget*) _tmp2_);
}


gint gpaste_settings_main_main (gchar** args, int args_length1) {
	gint result = 0;
	GPasteSettingsMain* _tmp0_;
	GPasteSettingsMain* app;
	GPasteSettingsMain* _tmp4_;
	gint _tmp5_ = 0;
	GError * _inner_error_ = NULL;
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	gtk_init (&args_length1, &args);
	_tmp0_ = gpaste_settings_main_new ();
	app = _tmp0_;
	{
		GPasteSettingsMain* _tmp1_;
		_tmp1_ = app;
		g_application_register ((GApplication*) _tmp1_, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp2_;
		const gchar* _tmp3_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = stderr;
		_tmp3_ = _ ("Fail to register the gtk application.\n");
		fprintf (_tmp2_, "%s", _tmp3_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (app);
		return result;
	}
	__finally0:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (app);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return 0;
	}
	_tmp4_ = app;
	_tmp5_ = g_application_run ((GApplication*) _tmp4_, 0, NULL);
	result = _tmp5_;
	_g_object_unref0 (app);
	return result;
}


int main (int argc, char ** argv) {
	g_type_init ();
	return gpaste_settings_main_main (argv, argc);
}


guint32 gpaste_settings_main_get_max_history_size (GPasteSettingsMain* self) {
	guint32 result;
	GSettings* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_;
	guint32 _tmp3_ = 0U;
	guint32 _tmp4_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "max-history-size");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_get_uint32 (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static GVariant* _variant_new1 (guint32 value) {
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}


void gpaste_settings_main_set_max_history_size (GPasteSettingsMain* self, guint32 value) {
	GSettings* _tmp0_;
	guint32 _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	_tmp2_ = _variant_new1 (_tmp1_);
	g_settings_set_value (_tmp0_, "max-history-size", _tmp2_);
	g_object_notify ((GObject *) self, "max-history-size");
}


guint32 gpaste_settings_main_get_element_size (GPasteSettingsMain* self) {
	guint32 result;
	GSettings* _tmp0_;
	GVariant* _tmp1_ = NULL;
	GVariant* _tmp2_;
	guint32 _tmp3_ = 0U;
	guint32 _tmp4_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "element-size");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_variant_get_uint32 (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_variant_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static GVariant* _variant_new2 (guint32 value) {
	return g_variant_ref_sink (g_variant_new_uint32 (value));
}


void gpaste_settings_main_set_element_size (GPasteSettingsMain* self, guint32 value) {
	GSettings* _tmp0_;
	guint32 _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	_tmp2_ = _variant_new2 (_tmp1_);
	g_settings_set_value (_tmp0_, "element-size", _tmp2_);
	g_object_notify ((GObject *) self, "element-size");
}


gboolean gpaste_settings_main_get_primary_to_history (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "primary-to-history");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_primary_to_history (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "primary-to-history", _tmp1_);
	g_object_notify ((GObject *) self, "primary-to-history");
}


gboolean gpaste_settings_main_get_synchronize_clipboards (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "synchronize-clipboards");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_synchronize_clipboards (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "synchronize-clipboards", _tmp1_);
	g_object_notify ((GObject *) self, "synchronize-clipboards");
}


gboolean gpaste_settings_main_get_track_changes (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "track-changes");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_track_changes (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "track-changes", _tmp1_);
	g_object_notify ((GObject *) self, "track-changes");
}


gboolean gpaste_settings_main_get_save_history (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "save-history");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_save_history (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "save-history", _tmp1_);
	g_object_notify ((GObject *) self, "save-history");
}


gboolean gpaste_settings_main_get_shutdown_on_exit (GPasteSettingsMain* self) {
	gboolean result;
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_boolean (_tmp0_, "shutdown-on-exit");
	result = _tmp1_;
	return result;
}


void gpaste_settings_main_set_shutdown_on_exit (GPasteSettingsMain* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = value;
	g_settings_set_boolean (_tmp0_, "shutdown-on-exit", _tmp1_);
	g_object_notify ((GObject *) self, "shutdown-on-exit");
}


static void gpaste_settings_main_class_init (GPasteSettingsMainClass * klass) {
	gpaste_settings_main_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GPasteSettingsMainPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpaste_settings_main_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpaste_settings_main_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpaste_settings_main_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE, g_param_spec_uint ("max-history-size", "max-history-size", "max-history-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_ELEMENT_SIZE, g_param_spec_uint ("element-size", "element-size", "element-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY, g_param_spec_boolean ("primary-to-history", "primary-to-history", "primary-to-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS, g_param_spec_boolean ("synchronize-clipboards", "synchronize-clipboards", "synchronize-clipboards", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_TRACK_CHANGES, g_param_spec_boolean ("track-changes", "track-changes", "track-changes", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_SAVE_HISTORY, g_param_spec_boolean ("save-history", "save-history", "save-history", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT, g_param_spec_boolean ("shutdown-on-exit", "shutdown-on-exit", "shutdown-on-exit", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpaste_settings_main_instance_init (GPasteSettingsMain * self) {
	self->priv = GPASTE_SETTINGS_MAIN_GET_PRIVATE (self);
}


static void gpaste_settings_main_finalize (GObject* obj) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (obj);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->window);
	G_OBJECT_CLASS (gpaste_settings_main_parent_class)->finalize (obj);
}


GType gpaste_settings_main_get_type (void) {
	static volatile gsize gpaste_settings_main_type_id__volatile = 0;
	if (g_once_init_enter (&gpaste_settings_main_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GPasteSettingsMainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpaste_settings_main_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GPasteSettingsMain), 0, (GInstanceInitFunc) gpaste_settings_main_instance_init, NULL };
		GType gpaste_settings_main_type_id;
		gpaste_settings_main_type_id = g_type_register_static (GTK_TYPE_APPLICATION, "GPasteSettingsMain", &g_define_type_info, 0);
		g_once_init_leave (&gpaste_settings_main_type_id__volatile, gpaste_settings_main_type_id);
	}
	return gpaste_settings_main_type_id__volatile;
}


static void _vala_gpaste_settings_main_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (object);
	switch (property_id) {
		case GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE:
		g_value_set_uint (value, gpaste_settings_main_get_max_history_size (self));
		break;
		case GPASTE_SETTINGS_MAIN_ELEMENT_SIZE:
		g_value_set_uint (value, gpaste_settings_main_get_element_size (self));
		break;
		case GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY:
		g_value_set_boolean (value, gpaste_settings_main_get_primary_to_history (self));
		break;
		case GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS:
		g_value_set_boolean (value, gpaste_settings_main_get_synchronize_clipboards (self));
		break;
		case GPASTE_SETTINGS_MAIN_TRACK_CHANGES:
		g_value_set_boolean (value, gpaste_settings_main_get_track_changes (self));
		break;
		case GPASTE_SETTINGS_MAIN_SAVE_HISTORY:
		g_value_set_boolean (value, gpaste_settings_main_get_save_history (self));
		break;
		case GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT:
		g_value_set_boolean (value, gpaste_settings_main_get_shutdown_on_exit (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpaste_settings_main_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GPasteSettingsMain * self;
	self = GPASTE_SETTINGS_MAIN (object);
	switch (property_id) {
		case GPASTE_SETTINGS_MAIN_MAX_HISTORY_SIZE:
		gpaste_settings_main_set_max_history_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_MAIN_ELEMENT_SIZE:
		gpaste_settings_main_set_element_size (self, g_value_get_uint (value));
		break;
		case GPASTE_SETTINGS_MAIN_PRIMARY_TO_HISTORY:
		gpaste_settings_main_set_primary_to_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_SYNCHRONIZE_CLIPBOARDS:
		gpaste_settings_main_set_synchronize_clipboards (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_TRACK_CHANGES:
		gpaste_settings_main_set_track_changes (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_SAVE_HISTORY:
		gpaste_settings_main_set_save_history (self, g_value_get_boolean (value));
		break;
		case GPASTE_SETTINGS_MAIN_SHUTDOWN_ON_EXIT:
		gpaste_settings_main_set_shutdown_on_exit (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



